-- compile arithmetic expressions, optimized

local MT={}
local N=0
local V={}
local F={
	["add"]="%s+%s",		-- infix format
	["sub"]="%s-%s",
	["mul"]="%s*%s",
	["div"]="%s/%s",
	["unm"]="-%s",
	["pow"]="%s^%s",
	["call"]="%s(%s)",
}

local function var(name)
	if name==nil then
		N=N+1
		name="t"..N
	end
	return setmetatable({name=name},MT)
end

local function S(a)
	if type(a)=="table" then return a.name else return a or "NIL" end
end

local function arith(a,b,op)
	local i=string.format(F[op],S(a),S(b))
	local v=V[i]
	if v==nil then
		v=var()
		print(v.name .." = "..i)
		V[i]=v			-- optimization
	end
	return v
end

for k,v in pairs(F) do
	MT["__"..k]=function (a,b) return arith(a,b,k) end
	--F[k]=k.."(%s,%s)"		-- prefix format
	--F[k]="%s %s "..k		-- postfix format
end

local function vars(s)
	print("var "..s)
	for x in string.gmatch(s,"(%w+)") do _G[x]=var(x) end
end

local function eval(v)
	N=0
	print("return "..v.name)
	print()
end

-- compile some expressions

vars"x,y,sin"
eval(y^2-x^3-5*x)
eval((x^2-y^2)/(x^2+y^2))
eval(sin(x))

vars"a,b,c"
eval((a*a+b*b)*(a*a-b*b)/(a*a+b*b+c)+(a*(b*b)*c))
eval(-a)
